
/*============================================================================
														  Motorola 68HC11
 SERIAL.C - Serial Communication Program

	Version:	1.0

	Author:		Axiom Mfg.
	Date:		3\9\1997
	Files:		SERIAL.C
	Tools:   	ImageCraft C Compiler V3.5

 =============================================================================*/
// to build, at the command prompt type:   imake -f serial.mak

#include <hc11.h>

// Constants
#define MAXBUF	300		// maximum number of serial bytes received in 1 string

// Function Prototypes
// Global Variables - used to decrease code size
char	Ibyte;			// serial input byte
char	count;			// temporary counter
char	Rcount1;		// number of serial input characters received
char	Ibuf1[MAXBUF];		// serial input buffer - COM1

// this function only used for debugging in buffalo monitor
void break1(){
	count=count;	                    // do nothing
}

// reset function.  timer, serial ports and counters are all reset.
void ResetCommand(){
	TFLG2 |= 0x80;	// clear timer overflow flag
	DDRD |= 0x3C;	// set PD2-PD5 to output

	// initialize internal serial port
	BAUD = 0x30;			// 9600 baud, N,8,1
	SCCR1 = 0;
	SCCR2 = 0x0C;

	Rcount1 = 0; 	// reset receive counter
}

// After executing STARTUP code on reset, execution begins here
main(){
	ResetCommand();		// perform software reset

	// main loop .. endless
	for( ; ;){
		// Test RS232 Incomming
		if(SCSR & 0x20){	// if incomming serial data on COM1
	        Ibyte = SCDR;			// get input byte
			if(Rcount1 < MAXBUF){	// if room to save this byte
	        	Ibuf1[Rcount1] = Ibyte;	// save it
				++Rcount1;		// increment receive counter
			}
		}

		// we're not using this timer now, but it's here if needed
		if(TFLG2 & 0x80){	// if timer overflow
			TFLG2 |= 0x80;		// clear timer overflow flag
		}
	}
}
